-- noBrainPlusLayout.lua
local NameOfLayout = "noBrainPlus"
local Description
local layerFrame

local debugging = false

local function Layout(mainFrame, cds)
	
	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()
	
	--RunScript(MoonTime_DB["Layout_noBrain"]["boxtext"])
	RunScript(MoonTime_mynext_start .. MoonTime_DB["Layout_noBrain"][MoonTime_DB["Layout_noBrain"]["rotation"]] .. " end")
	
	
	
	
	
	
	
	local time_newicon = GetTime();
	local oldcast = mynext(cds);
	local newcast;
	local dim;
	
	local isLunar
	local isSolar
	local eclipseDirection
	local eclipsePower
	local MF_CD
	local SunF_CD
	local IS_CD
	local FF_CD
	local charges, cd
	
	local MoonTimeNextCastframe
	local MoonTimeEclipseframe
	local MoonTimeMFframe
	local MoonTimeSunFframe
	local MoonTimeFaerieFireframe
	
	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	
	
	local TierListe = {}
	
	
	
	
	
	local a
	local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId
	local index, value
	local name, texture, tier, column, selected, available
	local charges, maxCharges, start, charge_duration
	local talentduration
	local CD, duration
	local bla
	
	
	local xdim = MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["xdim"];
	local ydim = MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["ydim"];
	
	
	local function isSolar()
		if EPower > 0 then
			return true
			else
			return false
		end
	end
	
	local function isLunar()
		return not isSolar()
	end
	
	
	
	layerFrame.Update = function()
		
		
		
		
		Treants_CD = cds:GetTreantsCD()
		
		
		eclipseDirection, eclipsePower = cds:GetEclipseDirection()
		MF_CD = cds:GetMoonfireCD()
		SunF_CD = cds:GetSunfireCD()
		FF_CD = cds:GetFaerieFireCD()
		CA_CD = cds:GetCelestialAlignmentCD()
		
		-- MoonTimeNextCastframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["active"] ) then 
			-- MoonTimeNextCastframe:Show()
			-- newcast = FF_icon
			newcast = mynext(cds)
			
			if oldcast ~= newcast then
				time_newicon = GetTime();
			end
			oldcast = newcast
			
			
			MoonTimeNextCastframe:SetIcon(newcast)
			
			xdim = MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["xdim"]
			ydim = MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["xdim"]
			alpha = 1
			
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][newcast] then
				-- GetTime-time_newicon -- wenn 0 volle gre
				-- wenn time_descale normale gre
				xdim = xdim * max(MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5), 1);
				ydim = ydim * max(MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5), 1);
				alpha = min( 0.75+((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5/2 , 1 )
			end
			
			
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["noBrainTile_EclipsePower"] then
				if eclipsePower > 0 then
					MoonTimeNextCastframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
					else
					MoonTimeNextCastframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
				end 
			end
			
			
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["glow"] then
				if ( isSolar or isLunar ) then
					MoonTimeNextCastframe:ShowGlow()
					else
					MoonTimeNextCastframe:HideGlow()
				end 
			end
			-- MoonTimeNextCastframe:SetTextHeight(20)
			
			MoonTimeNextCastframe.texture:SetVertexColor(1,1,1,alpha)
			MoonTimeNextCastframe:SetHeight(ydim)
			MoonTimeNextCastframe:SetWidth(xdim)
			
			
			
			
			alpha = 1;
			else
			MoonTimeNextCastframe:Hide()
		end
		
		
		
		
		-- MoonTimeEclipseframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["active"] ) then
			if eclipsePower > 0 then
				MoonTimeEclipseframe:SetIcon(Solar_icon)
				else
				MoonTimeEclipseframe:SetIcon(Lunar_icon)
			end
			MoonTimeEclipseframe:Show()
			
			if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["appearance"] == "text" ) then
				
				if eclipsePower <= 0 then
					if eclipseDirection == "moon" then
						MoonTimeEclipseframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
						else
						MoonTimeEclipseframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
					end
					else
					
					if eclipseDirection == "moon" then
						MoonTimeEclipseframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
						else
						MoonTimeEclipseframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
					end
					
				end
				-- MoonTimeEclipseframe:SetTextHeight(10)
				
			end
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["glow"] then
				if abs(eclipsePower) == 100 then
					MoonTimeEclipseframe:ShowGlow()
					else
					MoonTimeEclipseframe:HideGlow()
				end 
			end
			else
			MoonTimeEclipseframe:Hide()
		end
		
		
		
		-- MoonTimeMFframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["active"] ) then
			MoonTimeMFframe:SetText( '' )
			MoonTimeMFframe:Show()
			
			if ( MF_CD > 0 ) then
				if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["appearance"] == "text" then
					MoonTimeMFframe:SetText( '|cfff6ffff' .. math.ceil(MF_CD) .. '|r' )
					elseif MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["appearance"] == "popup" then
					MoonTimeMFframe:Hide()
					else
					MoonTimeMFframe:SetText( ' ' )
				end
			end
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["glow"] then
				if ( MF_CD <= 0 ) then
					MoonTimeMFframe:ShowGlow()
					else
					MoonTimeMFframe:HideGlow()
				end 
			end
			else
			MoonTimeMFframe:Hide()
		end	
		
		
		
		
		-- MoonTimeSunFframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["active"] ) then
			MoonTimeSunFframe:SetText( '' )
			MoonTimeSunFframe:Show()
			
			if ( SunF_CD > 0 ) then
				if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["appearance"] == "text" then
					MoonTimeSunFframe:SetText( '|cfff6ffff' .. math.ceil(SunF_CD) .. '|r' )
					elseif MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["appearance"] == "popup" then
					MoonTimeSunFframe:Hide()
					else
					MoonTimeSunFframe:SetText( ' ' )
				end
			end
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["glow"] then
				if ( SunF_CD <= 0 ) then
					MoonTimeSunFframe:ShowGlow()
					else
					MoonTimeSunFframe:HideGlow()
				end 
			end
			else
			MoonTimeSunFframe:Hide()
		end	
		
		
		-- MoonTimeFaerieFireframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["active"] ) then
			
			MoonTimeFaerieFireframe:SetText( '' )
			MoonTimeFaerieFireframe:Show()
			
			if ( FF_CD > 1.5 ) then
				if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["appearance"] == "text" then
					if FF_CD > 99 then
						MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD/60) .. 'm|r' )
						else
						MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD) .. '|r' )
					end
					elseif MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["appearance"] == "popup" then
					MoonTimeFaerieFireframe:Hide()
					else
					MoonTimeFaerieFireframe:SetText( ' ' )
				end
			end
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["glow"] then
				if ( FF_CD < 0 ) then
					MoonTimeFaerieFireframe:ShowGlow()
					else
					MoonTimeFaerieFireframe:HideGlow()
				end 
			end
			else
			MoonTimeFaerieFireframe:Hide()
		end
		
		-- MoonTimeCelestialAlignmentframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["active"] ) then
			
			MoonTimeCelestialAlignmentframe:SetText( '' )
			MoonTimeCelestialAlignmentframe:Show()
			
			
			if ( CA_CD > 0 ) then
				if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "text" then
					if CA_CD > 175 then
						MoonTimeCelestialAlignmentframe:SetText( '|cffffff00' .. string.format('%2.0f',CA_CD-165) .. '|r' )
						elseif CA_CD > 165 then
						MoonTimeCelestialAlignmentframe:SetText( '|cffffff00' .. string.format('%2.1f',CA_CD-165) .. '|r' )
						elseif CA_CD > 99 then
						MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD/60) .. 'm|r' )
						elseif CA_CD < 10 then
						MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. string.format('%2.1f',CA_CD) .. '|r' )
						else
						MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD) .. '|r' )
					end
					elseif MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "popup" then
					MoonTimeCelestialAlignmentframe:Hide()
					else
					MoonTimeCelestialAlignmentframe:SetText( ' ' )
				end
			end
			
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["glow"] then
				if ( CA_CD < 0 ) then
					MoonTimeCelestialAlignmentframe:ShowGlow()
					else
					MoonTimeCelestialAlignmentframe:HideGlow()
				end 
			end
			else
			MoonTimeCelestialAlignmentframe:Hide()
		end
		
		
		-- Chargesframe
		if ( MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["active"] ) then
			charges, cd = cds:GetCharges()
			maxCharges = 3
			
			
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["glow"] then
				if ( charges == maxCharges ) then
					MoonTimeChargesframe:ShowGlow()
					else
					MoonTimeChargesframe:HideGlow()
				end 
			end
			
			MoonTimeChargesframe:SetText( charges )
			
			if MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["appearance"] == "text" and charges < maxCharges then
				MoonTimeChargesframe:SetChargesText( math.ceil(cd) )
				else
				MoonTimeChargesframe:SetChargesText( '' )
			end
			
			
			
			
			
			charges = nil
			
			MoonTimeChargesframe:Show()
			else
			MoonTimeChargesframe:Hide()
		end
		
		
		-- TierFrames	
		for a = 1, 7, 1 do
			for b = 1, 3 do
				
				_, name, texture, selected, available = GetTalentInfo(a,b,GetActiveSpecGroup())	
				charges, maxCharges, start, charge_duration = GetSpellCharges(name)
				
				
				if (a-1)*3+b == 11 or (a-1)*3+b == 18 then
					talentduration = 30;
				end
				
				if ( selected and MoonTime_DB["Layout_noBrainPlus"][name]["active"] ) then
					CD, duration = cds:GetTalentCD(a,b)
					
					TierListe[name]:SetText( '' )
					TierListe[name]:Show()
					
					TierListe[name]:SetChargesText( '' )
					
					if charges then
						
						if charges < maxCharges then
							TierListe[name]:SetChargesText( math.ceil(start+charge_duration-GetTime()) )
						end
						
						else
						
						if ( CD > 0 ) then
							if MoonTime_DB["Layout_noBrainPlus"][name]["appearance"] == "text" then
								if talentduration > 0 and CD > duration-talentduration and CD-duration+talentduration < 10 then
									TierListe[name]:SetText( '|cfff6ff00' .. string.format('%2.1f',CD-duration+talentduration) .. '|r' )
									elseif CD > duration - talentduration then
									TierListe[name]:SetText( '|cfff6ff00' .. string.format('%2.0f',CD-duration+talentduration) .. '|r' )
									elseif CD > 99 then
									TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD/60) .. 'm|r' )
									else
									TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD) .. '|r' )
								end
								elseif MoonTime_DB["Layout_noBrainPlus"][name]["appearance"] == "popup" then
								TierListe[name]:Hide()
								else
								TierListe[name]:SetText( ' ' )
							end
						end
						
					end
					
					if MoonTime_DB["Layout_noBrainPlus"][name]["glow"] then
						if ( CD == 0 ) then
							TierListe[name]:ShowGlow()
							else
							TierListe[name]:HideGlow()
						end 
					end
					
					
					
					else
					TierListe[name]:Hide()
				end
			end
		end
		
		
		
	end	
	
	
	
	
	
	
	
	
	layerFrame.CreateCastFrame = function( spellTexture, RTframe, width, height, relwhich, relto, xoff, yoff )
		if not xoff then xoff= 0 end
		if not yoff then yoff= 0 end
		
		
		
		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, xoff, yoff)
		
		frame.texture = frame:CreateTexture("CastFrameTexture")
		
		frame.texture:SetTexture(spellTexture);
		frame.texture:SetAllPoints()
		
		local glowframe = CreateFrame( "Frame", "MTGlowframe", frame )
		glowframe:SetHeight(height*1.7)
		glowframe:SetWidth(width*1.7)
		glowframe:SetPoint("CENTER", frame, "CENTER", 0, 0)
		
		glowframe.texture = glowframe:CreateTexture("GlowFrameTexture")
		
		-- glowframe.texture:SetTexture(FF_icon)
		-- glowframe.texture:SetTexture("Interface\\BUTTONS\\CheckButtonGlow")
		glowframe.texture:SetTexture("Interface\\SpellActivationOverlay\\IconAlert")
		glowframe.texture:SetTexCoord(0, 0.5234375, 0.26953125, 0.53125)
		glowframe.texture:SetAllPoints()	
		glowframe.texture:Hide()
		
		
		local glowframe2 = CreateFrame( "Frame", "MTGlowframe2", frame )
		glowframe2:SetHeight(height*1.3)
		glowframe2:SetWidth(width*1.3)
		glowframe2:SetPoint("CENTER", frame, "CENTER", 0, 0)		
		
		glowframe2.texture = glowframe2:CreateTexture("GlowFrameTexture2")
		glowframe2.texture:SetTexture("Interface\\SpellActivationOverlay\\IconAlertAnts")
		
		glowframe2.texture:SetTexCoord(0, 0.1875, 0, 0.1875)
		glowframe2.texture:SetAllPoints()	
		glowframe2.texture:Hide()
		
		frame.ShowGlow = function ( self )
			glowframe.texture:Show()
			glowframe2.texture:Show()
			glowframe.texture:SetVertexColor(1,1,1,sin(GetTime()*350)/10+.90)
			
			local a = floor(mod(GetTime()*30,22))
			local b = mod(a,5)
			local c = floor(a/5)
			glowframe2.texture:SetTexCoord(0.1875*b, 0.1875*(b+1), 0.1875*c, 0.1875*(c+1))
		end
		
		
		frame.HideGlow = function ( self )
			glowframe.texture:Hide()
			glowframe2.texture:Hide()
		end
		
		
		-- frame.GetGlowFrame = function ( self )
		-- return glowframe
		-- end
		
		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		labelframe:SetTextColor( 1, 1, 1, 1 );
		
		
		-- find a good textheight
		local textheight = min(height,24);
		labelframe:SetFont("Fonts\\FRIZQT__.TTF", textheight, "THICKOUTLINE")
		
		-- if width < 36 then
		-- labelframe:SetText("10")
		-- else
		-- labelframe:SetText("8m")
		-- end
		
		
		while labelframe:GetStringWidth()-2 > frame:GetWidth() and textheight>2 do
			textheight = textheight-1;
			labelframe:SetFont("Fonts\\FRIZQT__.TTF", textheight, "THICKOUTLINE")
		end	
		
		labelframe:SetPoint("CENTER", frame, "CENTER",2,-floor(textheight/10+.5))--ceil(labelframe:GetWidth()-frame:GetWidth())/2,-1)
		
		
		labelframe:SetText("")
		local h
		
		frame.SetText = function( self, msg )
			msg = tostring(msg)
			
			if( msg == '' ) then
				self.texture:SetVertexColor(1,1,1,1)		
				else
				self.texture:SetVertexColor(1,1,1,.5)	
				
				msgtext = msg:gsub('|r', '')
				msgtext = msgtext:gsub('|c........', '')
				msgtext = msgtext:gsub('.', '8')	
				
				
				-- find the correct textheight
				h = round(frame:GetHeight()/2)
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")
				
				labelframe:SetText(msgtext)
				
				while labelframe:GetStringWidth()-2 > frame:GetWidth() and h>2 do
					h = h-1;
					labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")
				end	
				
			end
			
			labelframe:SetText(msg)
		end
		
		local chargesframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		chargesframe:SetPoint("TOPLEFT", frame, "TOPLEFT")
		chargesframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",0,0)
		chargesframe:SetTextColor( .8, .8, .8, 1 );
		chargesframe:SetJustifyH("RIGHT")
		chargesframe:SetJustifyV("BOTTOM")
		
		
		
		frame.SetChargesText = function( self, msg )
			chargesframe:SetText(msg)
			
			-- find the correct textheight
			h = 8;
			--while chargesframe:GetStringWidth() > self:GetWidth()/2 and h>1 do
			--				chargesframe:SetFont("Fonts\\FRIZQT__.TTF", h, "OUTLINE")
			--h = h-1;					
			--end
		end
		
		
		frame.SetTextHeight = function( self, height )
			fontName, fontHeight, fontFlags = labelframe:GetFont()
			
			if fontHeight > height then
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", height, "THICKOUTLINE")
			end		
		end
		
		
		frame.SetJustifyH = function( self, H )
			labelframe:SetJustifyH(H);
		end
		
		frame.SetJustifyV = function( self, V )
			labelframe:SetJustifyV(V);
		end			
		
		frame.SetIcon = function( self, icon )
			self.texture:SetTexture(icon)
		end
		
		return frame
	end
	
	
	-- layerFrame.CreateDualFrame = function ( frame, spellTexture )
	-- frame.texture:SetTexCoord(0, 0.5, 0, 1)
	-- frame.texture:SetWidth(frame.texture:GetWidth()/2)
	-- frame.texture:SetPoint("RIGHT", frame, "CENTER")
	-- frame.texture:SetTexture(spellTexture);
	
	-- frame.texture2 = frame:CreateTexture("CastFrameTexture2")
	-- frame.texture2:SetWidth(frame.texture:GetWidth())
	-- frame.texture2:SetHeight(frame.texture:GetHeight())
	-- frame.texture2:SetTexture(spellTexture);
	-- frame.texture2:SetTexCoord(0.5, 1, 0, 1)
	-- frame.texture2:SetPoint("LEFT", frame, "CENTER")
	-- frame.texture2:SetPoint("LEFT", frame, "CENTER")
	-- return frame
	-- end
	
	
	layerFrame.CreateDualFrame = function ( frame, spellTexture )
		frame.texture:SetGradientAlpha("HORIZONTAL", 1, 1, 1, 1, 1, 1, 1, 0)
		
		frame.texture2 = frame:CreateTexture("CastFrameTexture2")
		frame.texture2:SetTexture(spellTexture);
		frame.texture2:SetGradientAlpha("HORIZONTAL", 1, 1, 1, 0, 1, 1, 1, .86)
		frame.texture2:SetAllPoints()
		
		return frame
	end
	
	
	layerFrame.createLayout = function ()
		MoonTimeMFframe = layerFrame.CreateCastFrame( MF_icon, layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeMFframe"]["yoffset"])
		MoonTimeSunFframe = layerFrame.CreateCastFrame( SunF_icon, layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeSunFframe"]["yoffset"])
		MoonTimeFaerieFireframe = layerFrame.CreateCastFrame( FF_icon, layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeFaerieFireframe"]["yoffset"])
		MoonTimeEclipseframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeEclipseframe"]["yoffset"])
		MoonTimeNextCastframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeNextCastframe"]["yoffset"])
		MoonTimeCelestialAlignmentframe = layerFrame.CreateCastFrame( CA_icon, layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeCelestialAlignmentframe"]["yoffset"])
		
		MoonTimeChargesframe = layerFrame.CreateCastFrame( SS_icon, layerFrame, MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["xdim"], MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["xoffset"],MoonTime_DB["Layout_noBrainPlus"]["MoonTimeChargesframe"]["yoffset"])
		MoonTimeChargesframe = layerFrame.CreateDualFrame( MoonTimeChargesframe, SR_icon)
		
		
		
		for a = 1, 7, 1 do
			for b = 1, 3 do 
				local _, name, texture = GetTalentInfo(a,b,GetActiveSpecGroup())		
				TierListe[name] = layerFrame.CreateCastFrame( texture, layerFrame, MoonTime_DB["Layout_noBrainPlus"][name]["xdim"], MoonTime_DB["Layout_noBrainPlus"][name]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainPlus"][name]["xoffset"],MoonTime_DB["Layout_noBrainPlus"][name]["yoffset"])
			end
		end
	end	
	
	layerFrame.deleteLayout = function()
		MoonTimeNextCastframe:Hide()
		MoonTimeNextCastframe = nil
		MoonTimeEclipseframe:Hide()
		MoonTimeEclipseframe = nil
		MoonTimeMFframe:Hide()
		MoonTimeMFframe = nil
		MoonTimeSunFframe:Hide()
		MoonTimeSunFframe = nil
		MoonTimeFaerieFireframe:Hide()
		MoonTimeFaerieFireframe = nil
		MoonTimeCelestialAlignmentframe:Hide()
		MoonTimeCelestialAlignmentframe = nil
		
		for a = 1, 7, 1 do
			for b = 1, 3 do
				local _, name, texture = GetTalentInfo(a,b,GetActiveSpecGroup())			
				TierListe[name]:Hide()
				TierListe[name] = nil
			end
		end
		
		layerFrame:Hide()
		layerFrame = nil
	end
	
	
	
	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIParent	)
	frame.ID = name
	frame:RegisterEvent("VARIABLES_LOADED");
	
	
	
	frame:SetScript("OnEvent", 
		function( self, event )
			
			frame:UnregisterAllEvents()
			-- if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
			-- werden die ausstehenden Events registriert
			if ( GetLocale() == "deDE" ) then
				frame.description = MoonTime_noBrainPlus_Strings["deDE"]["description"]
				else
				frame.description = MoonTime_noBrainPlus_Strings["enGB"]["description"]
			end
			
			frame:SetScript("OnUpdate", function(self, event, ... ) 		
				name = GetTalentInfo(7,1, 1);
				
				if name then
				frame:SetScript("OnUpdate",nil)
				MoonTimeDoorKeeper:RegisterLayout( self );
				end 
				
				end)
				-- end
				end)
				
				
				frame.createLayout = function( self ) 
				LayoutFrame = Layout(self.Mainframe, self.Objectframe)
				LayoutFrame:createLayout()
				end
				
				frame.Hide = function()
				--print("hide()")
				LayoutFrame:Hide()
				end
				frame.Show = function()
				--print("show()")
				LayoutFrame:Show()
				end
				frame.Update = function()
				LayoutFrame:Update()
				end
				
				frame.deleteLayout = function()
				LayoutFrame:deleteLayout()
				end
				
				
				
				end																		-- Ende initialize
				
				registerLayout(NameOfLayout)														