-- noBrainLayout.lua
local NameOfLayout = "noBrain"
local Description;
local layerFrame

local debugging = false



MoonTime_mynext_start = "function mynext(frame) "
.."local GetEclipseDirection = frame.GetEclipseDirection "
.."local charges, chargetime = frame.GetCharges() "
.."local MF_CD, MF_duration = frame.GetMoonfireCD() "
.."local MF_exp = MF_duration - MF_CD "
.."local SunF_CD, SunF_duration = frame.GetSunfireCD() "
.."local CA_CD = frame.GetCelestialAlignmentCD() "
.."local CA_duration = frame.GetCelestialAlignmentDuration() "
.."local IsEmpowered = frame.IsEmpowered "
.."local LunarEmpowered = frame.IsLunarEmpowered() "
.."local SolarEmpowered = frame.IsSolarEmpowered() "
.."local lunarpeak = frame.IsLunarPeak() "
.."local solarpeak = frame.IsSolarPeak() "
.."local EDir, EPower = GetEclipseDirection() "
.."local GetSetTalentInRow = frame.GetSetTalentInRow "
.."local Mastery = (GetCombatRating(CR_MASTERY)/12.26+15)/100; "
.."local _, _, _, SF_castTime  = GetSpellInfo(SF_id) SF_castTime = SF_castTime/1000 "
.."local _, _, _, W_castTime  = GetSpellInfo(W_id) W_castTime = W_castTime/1000 "
.."local _, _, _, SS_castTime  = GetSpellInfo(SS_id) SS_castTime = SS_castTime/1000 "
.." "
.."local spell, _, _, _, startTime, endTime, _, castID, _ = UnitCastingInfo(\"player\"); "
.." "
.."if endTime == nil then endTime = 0 end "
.."if startTime == nil then startTime = 0 end "
.." "
.."local gcdstart, gcd = GetSpellCooldown(8921); "
.."  gcd = max(gcdstart+gcd-GetTime(),0); "
.." "
.."local casttime = max(endTime/1000 - GetTime()+0.01, gcd); "
.." "
.."local GetLunarAmp = frame.GetLunarAmp "
.."local GetSolarAmp = frame.GetSolarAmp "
.."local GetFuturePower = frame.GetFuturePower "
.."local isSolar = frame.isSolar "
.."local isLunar = frame.isLunar "


local function Layout(mainFrame, cds)
	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()
	

	

	RunScript(MoonTime_mynext_start .. MoonTime_DB["Layout_noBrain"][MoonTime_DB["Layout_noBrain"]["rotation"]] .. " end")
	
	
	local time_newicon = GetTime();
	local oldcast = mynext(cds);
	local newcast;
	local dim = 36;
	
	local MoonTimeNextCastframe
	local MoonTimeStarrainframe
	local MoonTimeTreeframe
	
	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	
	
	
	
	
	
	layerFrame.Update = function()
		
		
		newcast = mynext(cds)
		
		if oldcast ~= newcast then
			time_newicon = GetTime();
		end
		oldcast = newcast
		
		dim = 48;
		alpha = 1;
		
		
		MoonTimeNextCastframe:SetIcon(newcast)
		if MoonTime_DB["Layout_noBrain"]["blinkspells"][newcast] then
			dim = max(48*MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5),48);
			alpha = min( 0.75+((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5/2 , 1 )
		end
		
		MoonTimeNextCastframe.texture:SetVertexColor(1,1,1,alpha)
		MoonTimeNextCastframe:SetHeight(dim)
		MoonTimeNextCastframe:SetWidth(dim)
		
		
		
		
		
		
		
		
		
	end
	
	layerFrame.CreateCastFrame = function( spellTexture, RTframe, height, width, relwhich, relto, xoff, yoff )
		if not xoff then xoff= 0 end
		if not yoff then yoff= 0 end
		
		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, xoff, yoff)
		
		frame.texture = frame:CreateTexture("CastFrameTexture")
		frame.texture:SetTexture(spellTexture);
		frame.texture:SetAllPoints()
		
		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		labelframe:SetPoint("TOPLEFT", frame, "TOPLEFT")
		labelframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
		labelframe:SetTextColor( 1, 1, 1, 1 );
		frame.SetText = function( self, msg )
			if( msg == '' ) then
				frame.texture:SetVertexColor(1,1,1,1)		
				else
				frame.texture:SetVertexColor(1,1,1,.5)	
			end
			labelframe:SetText(msg)
		end
		frame.SetIcon = function( self, icon )
			frame.texture:SetTexture(icon)
		end
		
		return frame
	end
	
	layerFrame.createLayout = function ()
		MoonTimeNextCastframe = layerFrame.CreateCastFrame( "", layerFrame, 48, 48, "CENTER", "CENTER",0,-27)
	end
	
	
	layerFrame.deleteLayout = function()
		MoonTimeNextCastframe:Hide()
		MoonTimeNextCastframe = nil
		
		layerFrame:Hide()
		layerFrame = nil
	end
	
	
	
	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIParent	)
	frame.ID = NameOfLayout
	--frame.description = Description
	frame:RegisterEvent("VARIABLES_LOADED");
	frame:SetScript("OnEvent", 
		function( self, event, name, ... )
			frame:UnregisterAllEvents()
			-- if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
			-- werden die ausstehenden Events registriert
			if ( GetLocale() == "deDE" ) then
				frame.description = MoonTime_noBrainConfig_Strings["deDE"]["description"]
				else
				frame.description = MoonTime_noBrainConfig_Strings["enGB"]["description"]
			end
			
			MoonTimeDoorKeeper:RegisterLayout(self);
			-- end
		end
	)
	
	frame.createLayout = function( self ) 
		LayoutFrame = Layout(self.Mainframe, self.Objectframe)
		LayoutFrame:createLayout()
	end
	
	frame.Hide = function()
		LayoutFrame:Hide()
	end
	frame.Show = function()
		LayoutFrame:Show()
	end
	frame.Update = function()
		LayoutFrame:Update()
	end
	
	frame.deleteLayout = function()
		LayoutFrame:deleteLayout()
	end
	
end																		-- Ende initialize

registerLayout(NameOfLayout)
